/**
 *  Copyright AZS Services 2002-2004 http://www.a2zss.com */
package com.a2zss.ISO8583.samples;

import com.a2zss.ISO8583.*;

public class isosample2 {
	
	
	public static void main(String[] args) {	
 
	System.out.println(System.getProperties());	
	Config conf=new Config();
    ISO8583II isosdk=new ISO8583II(conf);
	isosdk.setOutput(System.out);
	isosdk.setDebuglevel(3);
	// libray paremeters customization for BASE24
	conf.setBitmapFormat(true); // default false=binary
//	conf.setCustomHeader("ISO015000060".getBytes()); // custom header
	byte[] custHeader="ISO015000060".getBytes();
	int custHeaderLen=custHeader.length;
	conf.setCustomMaxLength(ISOField.F41_TERMINAL_ID,0,16); // default 8
	conf.setCustomMaxLength(ISOField.F52_PIN_DATA,0,16); // default 8
	conf.setCustomType(ISOField.F52_PIN_DATA,0,Type.TEXT); // default binary 8
	
	int n=10; // number of cycles to test performance
	try { if (args!=null) n=Integer.valueOf(args[0]).intValue();
	    } catch (Exception exl) { n=10;}
	
	long start=System.currentTimeMillis();
	
	for(int j=0; j<n; j++)
	{

	byte[] msgdata=
		("ISO0150000600200"+
		"B238800128E19018"+
		"0000000010000010"+
		"0020000000000012"+
		"4005091317280009"+ 
		"9609172805090508"+ 
		"0998400023637111"+ 
		"1222233334444=00"+ 
		"0810100000000000"+ 
		"0000105242000000"+ 
		"000000433GD   00"+ 
		"0000000000000MAS"+ 
		"TERCARD      TES"+ 
		"T AST. LOUIS    "+ 
		"MO US044NOTUSED "+ 
		"                "+ 
		"                "+ 
		"    8402AEAF33D1"+ 
		"F8D93B3012FCTOFC"+ 
		"TN+000013FCM PHO"+ 
		"E2000P1100000000"+ 
		"0000010").getBytes();

	// building iso message as follows from source data:
	Message message=null;
	byte[] custHeader2=new byte[custHeaderLen];
	try {
	System.out.println("Message to parse: '"+new String(msgdata)+"'");
	java.io.DataInputStream is=new java.io.DataInputStream(new InputStreamBuffer(msgdata));
	is.readFully(custHeader2);
	message=isosdk.parsePlain(is);
	} catch (Exception e) { 
			System.out.println("There was error parsing message ");
          		e.printStackTrace(System.out);
          		}
         // now let lib to format message (field length padding and everything
         // like that will happen internally in ISO8583 lib)
	byte[] data=null;
	try {
	    com.a2zss.util.BinaryString bs=new com.a2zss.util.BinaryString(); 
	    bs.append(custHeader2);
	    bs.append(isosdk.formatPlain(message));
	    data=bs.getData();
         
         // now you got data that could be written to tcp/ip socket outpustream
         // in this example is use System.out
         System.out.print("The cust header and formatted message ='"); 
         System.out.write(data);
         System.out.println("'");
         System.out.println();
         // in case of real use: someoutputstream.write(data);
	
	} catch (Exception e) { 
			System.out.println("There was error formatting message ");
          		e.printStackTrace(System.out);
          		}
       /// now parse back to objects   
	try {
	 // create a inputstream from formatted data and parse it back to objects
		java.io.DataInputStream is=new java.io.DataInputStream(new InputStreamBuffer(data));
		is.readFully(custHeader2);
	    Message message2=new Message(isosdk.parsePlain(is));
	 //System.out.println("Message contents: "+message2);
	 //or lets print out all fields we will find
	    java.lang.reflect.Field[] constFields=ISOBits.class.getDeclaredFields();
	    java.util.TreeMap nameMap=new java.util.TreeMap();
	    ISOField dummy=new ISOField();
	    for (int i=0; i<constFields.length; i++)
	    	nameMap.put(new Integer(constFields[i].getInt(dummy)), constFields[i].getName());
	    
	 for (int i=-3; i<128; i++) 
	  { ISOField isf=(ISOField)message2.getISOField(i);
	    if (isf!=null) System.out.println("Found field "+i+"(name="+nameMap.get(new Integer(i)) +")='"+isf.getStringValue()+"'");
	    }
	
	} catch (Exception e) { 
		System.out.println("There was error parsing message ");
		e.printStackTrace(System.out);
			}
	} // for n

	long end=System.currentTimeMillis();
	System.out.println(n+" cycles done in "+(end-start)+ " ms");
	
	} // main
	

} // isosample